#define MAXDP 20
#define MAXSTR 256

#include <stdio.h>
#include <time.h>
#include <windows.h>

class CString;
class CDatum;
class CCas;
class CSalData;
class CDenData;

int HledejDatum(FILE *iSoubor, CDatum *iDatum);
int NactiNazevSalu(FILE *iSoubor);
int NactiRadekInformaci(FILE *iSoubor, int *oHodina, int *oMinuta, char *oNazev);
int NactiData(CDenData *iDenData, CDatum *iDatum, char *iSoubor);



class CString {
public:
	char *Obsah;
	
	CString(char *iObsah) {
		Obsah = new char[MAXSTR];
		Set(iObsah);
	}

	CString() {
		Obsah = new char[MAXSTR];
	}

	CString(CString *iString) {
		strncpy(Obsah, iString->Obsah, MAXSTR);
	}

	void Set(char *iObsah) {
		strncpy(Obsah, iObsah, MAXSTR);
	}

	~CString() {
		delete[] Obsah;
	}
};

class CDatum {
public:
	int DenTydne;
	int Den;
	int Mesic;
	int Rok;

	CDatum() {
	}

	CDatum(int iDen, int iMesic, int iRok) {
		Set(iDen, iMesic, iRok);
	}

	void Aktualni() {
		time_t Cas;
		time(&Cas);

		tm *DatumACas;
		DatumACas = localtime(&Cas);

		Den = DatumACas->tm_mday;
		Mesic = DatumACas->tm_mon + 1;
		Rok = DatumACas->tm_year + 1900;
		DenTydne = DatumACas->tm_wday;
	}

	void Set(int iDen, int iMesic, int iRok) {
		Den = iDen;
		Mesic = iMesic;
		Rok = iRok;

		tm DatumACas;
		DatumACas.tm_hour = 0;
		DatumACas.tm_min = 0;
		DatumACas.tm_sec = 0;
		DatumACas.tm_mday = Den;
		DatumACas.tm_mon = Mesic - 1;
		DatumACas.tm_year = Rok - 1900;
		mktime(&DatumACas);
		DenTydne = DatumACas.tm_wday;
	}
};

class CCas {
public:
	int Hodina;
	int Minuta;

	CCas() {
	}

	CCas(int iHodina, int iMinuta) {
		Set(iHodina, iMinuta);
	}

	void Aktualni() {
		time_t Cas;
		time(&Cas);

		tm *DatumACas;
		DatumACas = localtime(&Cas);

		Hodina = DatumACas->tm_hour;
		Minuta = DatumACas->tm_min;
	}

	void Set(int iHodina, int iMinuta) {
		Hodina = iHodina;
		Minuta = iMinuta;
	}
};

class CSalData {
public:
	CCas *Cas;
	CString *Nazev;
	int Pocet;

	CSalData() {
		Cas = new CCas[MAXDP];
		Nazev = new CString[MAXDP];

		Pocet = 0;
	}

	void Add(CCas *iCas, CString *iNazev) {
		Cas[Pocet].Set(iCas->Hodina, iCas->Minuta);
		Nazev[Pocet].Set(iNazev->Obsah);
		Pocet ++;
	}

	~CSalData() {
		delete[] Cas;
		delete[] Nazev;
	}
};

class CDenData {
public:
	CDatum Datum;
	CSalData Astrosal, Starvid;
};


int HledejDatum(FILE *iSoubor, CDatum *iDatum) {

	int Den, Mesic, Rok;

	int vstup;
	while ( (vstup = fgetc(iSoubor)) != EOF ) {
		if (vstup == '*') {
			fscanf(iSoubor, "%d.%d.%d\n", &Den, &Mesic, &Rok);
			if ( (Den == iDatum->Den) && (Mesic == iDatum->Mesic) && (Rok == iDatum->Rok) ) {
				return TRUE;
			}
		}
	}

	return FALSE;
}

int NactiNazevSalu(FILE *iSoubor) {
	int Znak;
	int Pozice = 0;

	while ((Znak = fgetc(iSoubor)) != '\n') {
	}
	return TRUE;
}

int NactiRadekInformaci(FILE *iSoubor, int *oHodina, int *oMinuta, char *oNazev) {
	int Znak;
	int Pozice = 0;

	Znak = fgetc(iSoubor);
	if (Znak == '*') return FALSE;
	if (Znak == 'A') return 2;
	if (Znak == 'S') return 3;
	fseek(iSoubor, -1, SEEK_CUR);

	if (fscanf(iSoubor, "%d:%d - ", oHodina, oMinuta) != 2) return FALSE;
	while ((Znak = fgetc(iSoubor)) != '\n') {
		oNazev[Pozice] = Znak;
		Pozice ++;
		if (Pozice >= MAXSTR) return FALSE;
	}
	oNazev[Pozice] = 0;

	return TRUE;
}

int NactiData(CDenData *iDenData, CDatum *iDatum, char *iSoubor) {
	FILE *Soubor;

	int Hodina = 0, Minuta = 0;
	char Nazev[MAXSTR];
	int Sal = 0, Stav = 0;
	CCas Cas;
	CString String;

	Soubor = fopen(iSoubor, "rt");
	if (Soubor == NULL) return FALSE;

	if (HledejDatum(Soubor, iDatum) != TRUE) {
		MessageBox(NULL, "Nepodailo se najt poadovan datum", "Informan obrazovka Planetria", MB_ICONERROR);
	} else {
		iDenData->Datum = *iDatum;
		while ( (Stav = NactiRadekInformaci(Soubor, &Hodina, &Minuta, Nazev)) != FALSE) {
			if (Stav != TRUE) Sal = Stav;
			else {
				Cas.Set(Hodina, Minuta);
				String.Set(Nazev);
				if (Sal == 2) iDenData->Astrosal.Add(&Cas, &String);
				if (Sal == 3) iDenData->Starvid.Add(&Cas, &String);
			}
		}
	}

	fclose(Soubor);

	return TRUE;
}
