#include <windows.h>
#include <ddraw.h>
#include <libgfle.h>

#include "Data.h"

#define APPNAME "Informan obrazovka Planetria"
#define CLASSNAME "IOP"


HINSTANCE GhInstance;
HWND Ghwnd;
UINT GCasovac;
BOOL GBDDraw;

float GZoom;
int GXSize, GYSize;


LPDIRECTDRAW4 GDDraw = NULL;
LPDIRECTDRAWSURFACE4 GddsFront = NULL;
LPDIRECTDRAWSURFACE4 GddsBack = NULL;

HRESULT InitDDraw() {
	DDSURFACEDESC2 ddsd;
	DDSCAPS2 ddscaps;

	if (FAILED(CoInitialize(NULL))) {
	return E_FAIL;
	}

	if (FAILED(CoCreateInstance( CLSID_DirectDraw,
							   NULL,
							   CLSCTX_ALL,
							   IID_IDirectDraw4,
							   (LPVOID *) &GDDraw ))) {
	return E_FAIL;
	} 

	IDirectDraw4_Initialize(GDDraw, NULL); 

	GDDraw->SetCooperativeLevel(Ghwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);

	GDDraw->GetDisplayMode(&ddsd);
	GDDraw->SetDisplayMode(ddsd.dwWidth, ddsd.dwHeight, ddsd.ddpfPixelFormat.dwRGBBitCount, ddsd.dwRefreshRate, 0);
//	GDDraw->SetDisplayMode(1024, 768, 32, 0, 0);

	GXSize = ddsd.dwWidth;
	GYSize = ddsd.dwHeight;
    
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize				= sizeof(ddsd);
	ddsd.dwFlags			=	DDSD_CAPS | 
								DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps		=	DDSCAPS_PRIMARYSURFACE | 
								DDSCAPS_FLIP | 
								DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount	= 1	;

	GDDraw->CreateSurface(&ddsd, &GddsFront, NULL);

    ZeroMemory(&ddscaps, sizeof(ddscaps));
    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;

	if (GddsFront->GetAttachedSurface(&ddscaps, &GddsBack)  != DD_OK) {
		MessageBox(NULL, "Chyba pi prci se souborem", "Nic", MB_ICONERROR);
	}

	return S_OK;
}

void ClearDDraw() {
	if (GDDraw) {
		if (GddsBack) GddsBack->Release();
		if (GddsFront) GddsFront->Release();
		GddsFront = NULL;
		GddsBack = NULL;

		GDDraw->RestoreDisplayMode();
		GDDraw->Release();
		GDDraw = NULL;
	}

	CoUninitialize();
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
	
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	
	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_SCREENSAVE:
		case SC_MONITORPOWER:
		case SC_KEYMENU:
			return 0;
		}
		break;

	case WM_TIMER:
		break;

	case WM_SETCURSOR:
		SetCursor(NULL);
		return TRUE;
	break;

	}

	return DefWindowProc(hwnd, msg, wParam, lParam);

}


BOOL CreateWin() {
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance = GhInstance;
	wc.lpfnWndProc = WndProc;
	wc.lpszClassName = CLASSNAME;
	wc.lpszMenuName = NULL;
	wc.style = CS_HREDRAW | CS_VREDRAW;

	if (!RegisterClassEx(&wc)) return FALSE;

	RECT WindowRect;
	WindowRect.left = 10L;
	WindowRect.top = 20L;
	WindowRect.right = 500L;
	WindowRect.bottom = 500L;

	Ghwnd = CreateWindowEx(0,
		CLASSNAME, APPNAME,
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		WindowRect.left, WindowRect.top, WindowRect.right, WindowRect.bottom,
		NULL, NULL, GhInstance, NULL);
	
	if (!Ghwnd) return FALSE;

	return TRUE;
}


HFONT GFontNadpis, GFontSaly, GFontCas, GFontPorady, GFontHodiny;
HBITMAP GBitmapPozadi; 

BOOL InitGDI(char *iSoubor) {
	LOGFONT logFont;

	RECT rect;
	GetClientRect(Ghwnd, &rect);
	GZoom = (float)rect.right/1024.0f;

	GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(logFont), &logFont);
	logFont.lfHeight = (int) (-48.0f*GZoom);
	logFont.lfItalic = FALSE;
	lstrcpy(logFont.lfFaceName, TEXT("Comic Sans MS"));
	GFontNadpis = CreateFontIndirect(&logFont);

	logFont.lfHeight = (int) (-38.0f*GZoom);
	logFont.lfItalic = TRUE;
	GFontSaly = CreateFontIndirect(&logFont);

	logFont.lfHeight = (int) (-28.0f*GZoom);
	logFont.lfItalic = FALSE;
	GFontCas = CreateFontIndirect(&logFont);

	logFont.lfHeight = (int) (-28.0f*GZoom);
	logFont.lfItalic = FALSE;
	GFontPorady = CreateFontIndirect(&logFont);

	logFont.lfHeight = (int) (-18.0f*GZoom);
	logFont.lfItalic = TRUE;
	GFontHodiny = CreateFontIndirect(&logFont);


	GFL_BITMAP *bitmap;
	GFL_LOAD_PARAMS lparams;
	GFL_ERROR Chyb;

	GBitmapPozadi = NULL;
	gflLibraryInit();
	gflGetDefaultLoadParams(&lparams);
	Chyb = gflLoadBitmap(iSoubor, &bitmap, &lparams, NULL);
	if (Chyb != GFL_NO_ERROR) {
		MessageBox(NULL, "Chyba pi natn obrzku", APPNAME, MB_ICONERROR);
		return FALSE;
	} else {
		gflConvertBitmapIntoDDB(bitmap, &GBitmapPozadi);
		gflFreeBitmapData(bitmap);
	}
	gflLibraryExit();

	return TRUE;
}

void ClearGDI() {
	DeleteObject(GFontNadpis);
	DeleteObject(GFontSaly);
	DeleteObject(GFontCas);
	DeleteObject(GFontPorady);
	DeleteObject(GFontHodiny);

	DeleteObject(GBitmapPozadi); 
}

//long GCitac = 0;

void Kresli(CDatum *iDatum, CCas *iCas, CDenData *iData) {
	HDC DC;

	iCas->Aktualni();

	if (GBDDraw) {
		GddsBack->GetDC(&DC);
	} else DC = GetDC(Ghwnd);

/*

	HBRUSH	hb	= CreateSolidBrush(RGB(255, 255, 255));
	RECT	obd = {0, 0, 1024, 768};

	SelectObject(DC, hb);
	FillRect(DC, &obd, hb);
	DeleteObject(hb);
*/


	if (GBitmapPozadi) {
		HDC hMemoryDC;
		BITMAP bitmap;

		hMemoryDC = CreateCompatibleDC(DC);
		SelectObject(hMemoryDC, GBitmapPozadi);
		GetObject(GBitmapPozadi, sizeof(bitmap), &bitmap);
		BitBlt(
			DC, 
			0, 0, bitmap.bmWidth, bitmap.bmHeight, 
			hMemoryDC, 
			0, 0, 
			SRCCOPY);
		DeleteDC(hMemoryDC); 
	}


	char Nadpis[256];
	char *SDenTydne;
	
	if (iDatum->DenTydne == 0) SDenTydne = "nedli";
	if (iDatum->DenTydne == 1) SDenTydne = "pondl";
	if (iDatum->DenTydne == 2) SDenTydne = "ter";
	if (iDatum->DenTydne == 3) SDenTydne = "stedu";
	if (iDatum->DenTydne == 4) SDenTydne = "tvrtek";
	if (iDatum->DenTydne == 5) SDenTydne = "ptek";
	if (iDatum->DenTydne == 6) SDenTydne = "sobotu";

	sprintf(Nadpis, "Program Planetria pro %s %d.%d.%d", SDenTydne, iDatum->Den, iDatum->Mesic, iDatum->Rok);

	SelectObject(DC, GFontNadpis);
	SetBkMode(DC, TRANSPARENT);
	SetTextColor(DC, 0x0000FFFF);
	TextOut(DC, (int) (70.0f*GZoom), (int) (50.0f*GZoom), Nadpis, strlen(Nadpis));

	SelectObject(DC, GFontSaly);
	SetBkMode(DC, TRANSPARENT);
	SetTextColor(DC, 0x000000FF);
	TextOut(DC, (int) (150.0f*GZoom), (int) (140.0f*GZoom), "Astrosl", strlen("Astrosl"));

	char SCas[20];
	int i, poradi = 0;

	for (i = 0; i < iData->Astrosal.Pocet; i ++) {
		if (iData->Astrosal.Cas[i].Hodina > (iCas->Hodina - 1)) {
			sprintf(SCas, "%02d:%02d", iData->Astrosal.Cas[i].Hodina,  iData->Astrosal.Cas[i].Minuta);
			SelectObject(DC, GFontCas);
			SetBkMode(DC, TRANSPARENT);
			SetTextColor(DC, 0x0000FF00);
			TextOut(DC, (int) (100.f*GZoom), (int) ((float)(220 + poradi*60)*GZoom), SCas, strlen(SCas));

			SelectObject(DC, GFontPorady);
			SetBkMode(DC, TRANSPARENT);
			SetTextColor(DC, 0x000000FF);
			TextOut(DC, (int) (200.f*GZoom), (int) ((float)(230 + poradi*60)*GZoom), iData->Astrosal.Nazev[i].Obsah, strlen(iData->Astrosal.Nazev[i].Obsah));

			poradi ++;
			if (poradi > 3) break;
		}
	}

	SelectObject(DC, GFontSaly);
	SetBkMode(DC, TRANSPARENT);
	SetTextColor(DC, 0x00FF0000);
	TextOut(DC, (int) (150.f*GZoom), (int) (470.f*GZoom), "Starvid", strlen("Starvid"));
	
	poradi = 0;
	for (i = 0; i < iData->Starvid.Pocet; i ++) {
		if (iData->Starvid.Cas[i].Hodina > (iCas->Hodina - 1)) {
			sprintf(SCas, "%02d:%02d", iData->Starvid.Cas[i].Hodina,  iData->Starvid.Cas[i].Minuta);
			SelectObject(DC, GFontCas);
			SetBkMode(DC, TRANSPARENT);
			SetTextColor(DC, 0x0000FF00);
			TextOut(DC, (int) (100.f*GZoom), (int) ((float)(550 + poradi*60)*GZoom), SCas, strlen(SCas));

			SelectObject(DC, GFontPorady);
			SetBkMode(DC, TRANSPARENT);
			SetTextColor(DC, 0x00FF0000);
			TextOut(DC, (int) (200.f*GZoom), (int) ((float)(560 + poradi*60)*GZoom), iData->Starvid.Nazev[i].Obsah, strlen(iData->Starvid.Nazev[i].Obsah));

			poradi ++;
			if (poradi > 2) break;
		}
	}

	SelectObject(DC, GFontHodiny);
	SetBkMode(DC, TRANSPARENT);
	SetTextColor(DC, 0x00FFFF00);
//	sprintf(SCas, "%02d:%02d - %d", iCas->Hodina,  iCas->Minuta, GCitac);
	sprintf(SCas, "%02d:%02d", iCas->Hodina,  iCas->Minuta);
	TextOut(DC, (int) (900.f*GZoom), (int) (700.f*GZoom), SCas, strlen(SCas));
//	GCitac ++;

	if (GBDDraw) {
		GddsBack->ReleaseDC(DC);
		GddsFront->Flip(NULL, DDFLIP_WAIT);
	}

}

int nofchrs(char *string, char ch) {
	int i = 0, j = 0;
	while (string[i] != 0) {
		if (string[i] == ch) j ++;
		i ++;
	}
	return j;
}

int getnstr(char *istr, char *ostr, int n) {
	int i = 0, j = 0;
	while (istr[i] != 0) {
		if (istr[i] == '\"') {
			j++;
//			int h = (j+1)/2;
			if ( ((j+1)/2) == n ) break;
		}
		i ++;
	}
	if (istr[i] == 0) return FALSE;

	i ++;
	j = 0;
	while (istr[i] != 0) {
		if (istr[i] == '\"') break;
		ostr[j] = istr[i];
		i ++;
		j ++;
	}
	ostr[j] = 0;
	if (istr[i] == 0) return FALSE;

	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {

	char SouborData[256], SouborPozadi[256];

	if (nofchrs(lpCmdLine, '\"') == 4) {
		getnstr(lpCmdLine, SouborData, 1);
		getnstr(lpCmdLine, SouborPozadi, 2);
	} else {
		strcpy(SouborData, "Data.txt");
		strcpy(SouborPozadi, "Pozadi.jpg");
	}

	CDatum DnesniDatum;
	CCas AktualniCas;

	DnesniDatum.Aktualni();
	AktualniCas.Aktualni();

	CDenData DenniData;

	if (NactiData(&DenniData, &DnesniDatum, SouborData) == FALSE) {
		MessageBox(NULL, "Chyba pi prci se souborem", APPNAME, MB_ICONERROR);
	}


	GhInstance = hInstance;

	if (!CreateWin()) return 0;

	GBDDraw = TRUE;

	if (GBDDraw) {
		if (!SUCCEEDED(InitDDraw())) {
			MessageBox(NULL, TEXT("Nepodailo se inicializovat DirectDDraw"), APPNAME, MB_ICONERROR);
//			return 0;
			GBDDraw = FALSE;
		} else GBDDraw = TRUE;
	}

	if (!InitGDI(SouborPozadi)) return 0;

//	ShowWindow(Ghwnd, SW_SHOWDEFAULT);
	UpdateWindow(Ghwnd);

	Kresli(&DnesniDatum, &AktualniCas, &DenniData);

	MSG msg;
	BOOL gm = TRUE;
	SetTimer(Ghwnd, GCasovac, 1000, NULL);
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		Kresli(&DnesniDatum, &AktualniCas, &DenniData);
	}

	ClearGDI();
	ClearDDraw();

	return msg.wParam;
}